//+======================================================================
// :  $
//
// Project:   Tango
//
// Description:  java source code for Tango manager tool..
//
// : pascal_verdier $
//
// Copyright (C) :      2004,2005,2006,2007,2008,2009,2010,2011,2012,2013,
//						European Synchrotron Radiation Facility
//                      BP 220, Grenoble 38043
//                      FRANCE
//
// This file is part of Tango.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//-======================================================================

package context_manager.commons;

import fr.esrf.TangoDs.TangoConst;
import fr.esrf.tangoatk.widget.util.ErrorPane;

import javax.swing.*;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import java.awt.*;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.URL;

/**
 * Class Description:
 * This class display a dialog with a list of command to be send to
 * the selected server.
 *
 * @author verdier
 */

public class PopupHtml extends JDialog implements TangoConst {

    protected JFrame parent;
    protected JEditorPane pane;
    private String urlFile;
    private static int lastOffset = 0;

    private static final String header =
            "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 3.2//EN\">\n" +
                    "<HTML>\n" +
                    "<HEAD>\n" +
                    "<Title> title </Title>\n" +
                    "</HEAD>\n" +
                    "<BODY TEXT=\"#000000\" BGCOLOR=\"#FFFFFF\" LINK=\"#0000FF\" VLINK=\"#7F00FF\" ALINK=\"#FF0000\">\n" +
                    "<P><!-------TITLE------></P>\n";
    private static final String footer =
            "</Body>\n" +
                    "</Html>\n";

    //===============================================================
    /**
     * Initializes the Form
     *
     * @param parent the parent form instance
     */
    //===============================================================
    public PopupHtml(JFrame parent) {
        this(parent, true);
    }
    //===============================================================
    /**
     * Initializes the Form
     *
     * @param parent the parent form instance
     */
    //===============================================================
    public PopupHtml(JFrame parent, boolean modal) {
        super(parent, modal);
        initComponents();

        this.parent = parent;
        pack();

        if (parent != null && parent.isVisible() && parent.getWidth() > 0) {
            Point p = parent.getLocationOnScreen();
            p.x += 10 + lastOffset;
            p.y += 10 + lastOffset;
            setLocation(p);

            Toolkit toolkit = Toolkit.getDefaultToolkit();
            Dimension screenSize = toolkit.getScreenSize();
            if (p.y < 0.5*screenSize.getHeight())
                lastOffset+=30;
            else
                lastOffset = 0;
        }
    }

    //===============================================================
    //===============================================================
    void setDistributionIcon(ImageIcon icon) {
        setIconImage(icon.getImage());
    }
    //===============================================================
    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the FormEditor.
     */
    //===============================================================
    private void initComponents() {//GEN-BEGIN:initComponents
        JPanel jPanel1 = new JPanel();
        JButton cancelBtn = new JButton();
        setBackground(new Color(198, 178, 168));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        cancelBtn.setText("Dismiss");
        cancelBtn.setHorizontalAlignment(SwingConstants.LEFT);
        cancelBtn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                dismissBtnActionPerformed(evt);
            }
        });

        jPanel1.add(cancelBtn);
        getContentPane().add(jPanel1, BorderLayout.SOUTH);

    }

    //======================================================
    //======================================================
    protected synchronized void setPage(URL url) {
        try {
            //	And Try to display page
            pane.setCursor(new Cursor(Cursor.WAIT_CURSOR));
            pane.setPage(url);
        } catch (IOException e) {
            ErrorPane.showErrorMessage(parent, null, e);
        }
        pane.setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
    }

    //======================================================
    //======================================================
    private String buildTmpFile(String code) {
        String urlstr = null;
        try {
            int random_value = new java.util.Random().nextInt(30000);
            String tmpdir = System.getProperty("java.io.tmpdir");
            urlFile = tmpdir + "/html." + random_value;
            FileOutputStream fidout = new FileOutputStream(urlFile);
            fidout.write((header + code + footer).getBytes());
            fidout.close();

            urlstr = "file:" + urlFile;
        } catch (Exception e) {
            ErrorPane.showErrorMessage(parent, null, e);
            e.printStackTrace();
        }
        return urlstr;
    }

    //======================================================
    @SuppressWarnings({"UnusedDeclaration"})
    private void closeDialog(java.awt.event.WindowEvent evt) {
        doClose();
    }
    //======================================================
    @SuppressWarnings({"UnusedDeclaration"})
    private void dismissBtnActionPerformed(java.awt.event.ActionEvent evt) {
        doClose();
    }
    //======================================================
    private void doClose() {
        try {
            if (urlFile != null)
                if (!new File(urlFile).delete())
                    System.err.println("Cannot delete " + urlFile);
        } catch (Exception e) {
            ErrorPane.showErrorMessage(parent, null, e);
        }
        setVisible(false);
        dispose();
    }
    //======================================================
    /**
     * Show the dialog window.
     *
     * @param code an URL address or HTML page source code.
     */
    //======================================================
    public void show(String code) {
        show(code, 700, 750);
    }
    //======================================================
    /**
     * Show the dialog window.
     *
     * @param code   an URL address or HTML page source code.
     * @param width  dialog size
     * @param height dialog size
     */
    //======================================================
    public void show(String code, int width, int height) {
        try {
            pane = new JEditorPane();
            pane.setEditable(false);
            //	add an hyperlink listener
            pane.addHyperlinkListener(new HyperlinkListener() {
                public void hyperlinkUpdate(HyperlinkEvent evt) {
                }
            });
            getContentPane().add(new JScrollPane(pane), BorderLayout.CENTER);
            setSize(width, height);
            URL url = new URL(buildTmpFile(code));
            setPage(url);
        } catch (IOException e) {
            e.printStackTrace(System.err);
            return;
        }
        setVisible(true);
    }
    //======================================================
    /**
     * Show the dialog window.
     *
     * @param url    specified URL to display.
     * @param width  dialog size
     * @param height dialog size
     */
    //======================================================
    @SuppressWarnings("unused")
    public void show(URL url, int width, int height) {
        pane = new JEditorPane();
        pane.setEditable(false);
        //	add an hyperlink listener
        pane.addHyperlinkListener(new HyperlinkListener() {
            public void hyperlinkUpdate(HyperlinkEvent evt) {
            }
        });
        getContentPane().add(new JScrollPane(pane), BorderLayout.CENTER);
        setSize(width, height);
        setPage(url);

        setVisible(true);
    }
    //===============================================================
    //===============================================================
    public static String title(String title) {
        return  "<font size=+2><b><u>" + title + "</u></b></font>";
    }
    //===============================================================
    //===============================================================
    public static String tableLine(String title, String value) {
        return "<tr><td><b> " + title + ":</b></td> " +
                "<td>" + value + "</td></tr>\n";
    }

    //===============================================================
    //===============================================================
    public static String tableLine(String title, String[] values) {
        if (values.length == 1) {
            //  Remove 's' at end
            if (title.endsWith("s"))
                title = title.substring(0, title.length() - 2);
            return tableLine(title, values[0]);
        }
        StringBuilder sb = new StringBuilder("<tr><td><b> " + title + ":</b></td> <td>");
        for (String value : values) {
            sb.append("<li>").append(value).append("\n");
        }
        return sb + "</td></tr>\n";
    }
    //===============================================================
    //===============================================================
}
